<template>
  <div class="evaluate">
    <div class="title">
      <span>社会治理</span>
      <img src="../../../assets/img/zonlan (9).png" alt="" />
    </div>
    <div id="upperChart" @click="geturl()"></div>
  </div>
</template>

<script>
import data from "@/assets/json/test.json";
export default {
  //import引入的组件需要注入到对象中才能使用
  components: {},
  data() {
    //这里存放数据
    return {
      dataJson: {},
      leftoption: {},
    };
  },
  //方法集合
  methods: {
    geturl() {
      this.$emit("geturl", true);
    },
    //获取数据
    async drawLine() {
      // 基于准备好的dom，初始化echarts实例
      // let leftChart = this.$echarts.init(document.getElementById("upperChart"));
      // 绘制图表
      // leftChart.setOption(this.leftoption);
      const { data: dt } = await this.$http.get(
        "/jeecg-boot/town_governance/townGovernance/queryall"
      );
      this.GetChartDataLeft1(dt.result);
    },

    GetChartDataLeft1(val) {
      this.$echarts.registerMap("weifang", this.dataJson);
      var myChart = this.$echarts.init(document.getElementById("upperChart"));

      //图例

      var convertLineData = function (data) {
        var res = [];
        for (var i = 0; i < data.length; i++) {
          var dataItem = data[i];
          var coordS = dataItem.lineS; //线起点
          var coordM = dataItem.lineM; //线中间点
          var coordE = dataItem.lineE; //线尾点
          if (coordS && coordM && coordE) {
            res.push({
              coords: [coordS, coordM, coordE],
            });
          }
        }
        return res;
      };
      var convertValData = function (data) {
        var res = [];
        for (var i = 0; i < data.length; i++) {
          var dataItem = data[i];
          res.push({
            name: dataItem.areaName,
            value: dataItem.lineE.concat(dataItem.value),
          });
        }
        return res;
      };
      var json = {
        data: [
          {
            areaName: "羊口镇",
            value: 94,
            lineS: [119, 37.2891],
            lineM: [119, 37.2891],
            lineE: [119.1648, 37.3991],
          },
          {
            areaName: "双王城生态经济园区",
            value: 10,
            lineS: [118.6645, 37.1783],
            lineM: [118.6645, 37.1783],
            lineE: [118.5082, 37.4333],
          },
          {
            areaName: "营里镇",
            value: 10,
            lineS: [118.9036, 37.1056],
            lineM: [118.9036, 37.1056],
            lineE: [119.0976, 37.1847],
          },
          {
            areaName: "侯镇",
            value: 10,
            lineS: [119.0879, 37.0709],
            lineM: [119.0879, 37.0709],
            lineE: [119.3154, 37.1178],
          },
          {
            areaName: "上口镇",
            value: 10,
            lineS: [118.8978, 37.0184],
            lineM: [118.8978, 37.0184],
            lineE: [119.273, 37.043],
          },
          {
            areaName: "台头镇",
            value: 10,
            lineS: [118.5832, 37.0527],
            lineM: [118.5832, 37.0527],
            lineE: [118.4065, 37.1705],
          },
          {
            areaName: "田柳镇",
            value: 10,
            lineS: [118.7494, 37.0235],
            lineM: [118.7494, 37.0235],
            lineE: [118.5228, 37.2651],
          },
          {
            areaName: "化龙镇",
            value: 10,
            lineS: [118.566, 36.9794],
            lineM: [118.566, 36.9794],
            lineE: [118.2834, 36.9774],
          },
          {
            areaName: "文家街道",
            value: 10,
            lineS: [118.6409, 36.9005],
            lineM: [118.6409, 36.9005],
            lineE: [118.3368, 36.7948],
          },
          {
            areaName: "孙家集街道",
            value: 10,
            lineS: [118.6494, 36.8277],
            lineM: [118.6494, 36.8277],
            lineE: [118.4494, 36.7632],
          },
          {
            areaName: "纪台镇",
            value: 10,
            lineS: [118.7462, 36.7588],
            lineM: [118.7462, 36.7588],
            lineE: [118.7519, 36.6098],
          },
          {
            areaName: "稻田镇",
            value: 10,
            lineS: [118.9252, 36.7774],
            lineM: [118.9252, 36.7774],
            lineE: [118.9887, 36.5527],
          },
          {
            areaName: "洛城街道",
            value: 10,
            lineS: [118.9717, 36.8976],
            lineM: [118.9717, 36.8976],
            lineE: [119.3143, 36.896],
          },
          {
            areaName: "古城街道",
            value: 10,
            lineS: [118.8086, 36.9325],
            lineM: [118.8086, 36.9325],
            lineE: [119.1319, 36.6972],
          },
          {
            areaName: "圣城街道",
            value: 10,
            lineS: [118.7405, 36.8564],
            lineM: [118.7405, 36.8564],
            lineE: [118.4782, 36.6103],
          },
        ],
      };
      // console.log(val);
      // let data1 = [];
      // let data2 = [];
      // let data3 = [];
      // let data4 = [];
      // let data5 = [];
      // let data6 = [];
      // let data7 = [];
      // val.forEach((e) => {
      //   json.data.forEach((v) => {
      //     if (e.towncode == "羊口") {
      //       v.shequ.push(e.value);
      //     }
      //     // if (e.name == "覆盖对象总数") {
      //     //   data2.push(e);
      //     // }
      //     // if (e.name == "已巡查网格数") {
      //     //   data3.push(e);
      //     // }
      //     // if (e.name == "网格数") {
      //     //   data4.push(e);
      //     // }
      //     // if (e.name == "网格员数") {
      //     //   data5.push(e);
      //     // }
      //     // if (e.name == "对象总数") {
      //     //   data6.push(e);
      //     // }
      //     // if (e.name == "已巡查社区/专属/村居数") {
      //     //   data7.push(e);
      //     // }
      //   });
      // });
      var data = json.data;
      var series = [];
      series.push(
        {
          name: "",
          type: "lines",
          zlevel: 2,

          symbol: "none",
          silent: true, //不响应鼠标点击或事件
          effect: {
            show: false, //关闭特效
          },
          tooltip: {
            show: false,
          },
          polyline: true, //支持多点连线
          lineStyle: {
            normal: {
              color: "white",
              width: 1.5,
              opacity: 0.9,
              curveness: 0,
            },
          },
          data: convertLineData(data),
        },
        {
          name: "",

          type: "scatter",
          coordinateSystem: "geo",
          zlevel: 2,
          hoverAnimation: false, //hover时不高亮点
          cursor: "default", //鼠标设置为箭头
          itemStyle: {
            normal: {
              color: "#FFF",
            },
          },
          tooltip: {
            show: false,
          },
          label: {
            normal: {
              show: true,
              position: "center",
              fontSize: 15,
              fontWeight: "bold",
              backgroundColor: "#06406e",
              color: "#fff",
              padding: [8, 8],
              formatter: function (param) {
                // console.log(param);
                return (
                  "社区数：" +
                  param.value[1] +
                  "\n" +
                  "已巡查数：" +
                  param.value[2] +
                  "\n" +
                  "网格数：" +
                  param.value[2] +
                  "\n" +
                  "已巡查网格数：" +
                  param.value[2] +
                  "\n" +
                  "对象总数：" +
                  param.value[2] +
                  "\n" +
                  "网格员数：" +
                  param.value[2]
                );
              },
            },
          },
          layoutCenter: ["50%", "30%"],

          data: convertValData(data),
        }
      );

      this.leftoption = {
        title: {
          text: "寿光市",
          subtext: "",
          left: "center",
          top: "2%",
          textStyle: {
            fontSize: 30,
            color: "#fff",
          },
        },
        tooltip: {
          trigger: "item",
        },
        legend: {
          show: false,
        },
        // grid: {
        //   top: "0%",
        // },
        geo: {
          map: "weifang",
          top: "5%",
          zoom: 0.6,
          roam: true,
          label: {
            normal: {
              show: true,
              textStyle: {
                color: "#000000",
                fontSize: 15,
              },
            },
          },

          itemStyle: {
            normal: {
              areaColor: "#323c4800", //地图颜色
              borderColor: "#0258b6",
              borderWidth: 1,
            },
          },
          regions: [
            //对不同的区块进行着色
            {
              name: "羊口镇", //区块名称
              itemStyle: {
                normal: {
                  areaColor: "#83bff9",
                },
              },
            },
            {
              name: "双王城生态经济园区",
              itemStyle: {
                normal: {
                  areaColor: "#83bff9",
                },
              },
            },
            {
              name: "营里镇",
              itemStyle: {
                normal: {
                  areaColor: "#d8a3c2",
                },
              },
            },
            {
              name: "台头镇",
              itemStyle: {
                normal: {
                  areaColor: "#7ac19c",
                },
              },
            },
            {
              name: "田柳镇",
              itemStyle: {
                normal: {
                  areaColor: "#b1c97e",
                },
              },
            },
            {
              name: "上口镇",
              itemStyle: {
                normal: {
                  areaColor: "#afd5d2",
                },
              },
            },
            {
              name: "侯镇",
              itemStyle: {
                normal: {
                  areaColor: "#c0d03d",
                },
              },
            },
            {
              name: "化龙镇",
              itemStyle: {
                normal: {
                  areaColor: "#d7bf84",
                },
              },
            },
            {
              name: "古城街道",
              itemStyle: {
                normal: {
                  areaColor: "#87d7d0",
                },
              },
            },
            {
              name: "文家街道",
              itemStyle: {
                normal: {
                  areaColor: "#e2a011",
                },
              },
            },
            {
              name: "圣城街道",
              itemStyle: {
                normal: {
                  areaColor: "#a9d672",
                },
              },
            },
            {
              name: "洛城街道",
              itemStyle: {
                normal: {
                  areaColor: "#a0c8f3",
                },
              },
            },
            {
              name: "孙家集街道",
              itemStyle: {
                normal: {
                  areaColor: "#e7ea74",
                },
              },
            },
            {
              name: "纪台镇",
              itemStyle: {
                normal: {
                  areaColor: "#9bd64d",
                },
              },
            },
            {
              name: "稻田镇",
              itemStyle: {
                normal: {
                  areaColor: "#f0ce69",
                },
              },
            },
          ],
        },
        series: series,
      };

      myChart.setOption(this.leftoption);
    },
  },
  mounted() {
    this.dataJson = data;
    this.drawLine();
  },
  created() {},
};
</script>
<style lang="less" scoped>
//@import url(); 引入公共css类
.evaluate {
  height: 100%;
  width: 100%;
  background: rgba(8, 32, 58, 0.7);
  .title {
    width: 100%;
    position: relative;

    img {
      width: 100%;
    }

    span {
      font-size: 78px;
      font-weight: 400;
      color: #ffe86b;
      background: linear-gradient(0deg, #bce7ff 0%, #69efff 98.6572265625%);
      -webkit-background-clip: text;
      -webkit-text-fill-color: transparent;
      position: absolute;
      left: 50%;
      top: 0;
      transform: translateX(-50%);
    }
  }
}
#upperChart {
  height: 100%;
  width: 100%;
}
@media only screen and (max-width: 2560px) {
  .evaluate {
    height: auto;
    overflow: visible;
    background: transparent;
    #upperChart {
      height: 6000px;
    }
  }
}
</style>
